/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../../common";

export interface FreeCollectModuleInterface extends utils.Interface {
  functions: {
    "OSP()": FunctionFragment;
    "getFollowerOnlyByPublicationByProfile(uint256,uint256)": FunctionFragment;
    "initializePublicationCollectModule(uint256,uint256,bytes)": FunctionFragment;
    "processCollect(uint256,address,uint256,uint256,bytes)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "OSP"
      | "getFollowerOnlyByPublicationByProfile"
      | "initializePublicationCollectModule"
      | "processCollect"
  ): FunctionFragment;

  encodeFunctionData(functionFragment: "OSP", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "getFollowerOnlyByPublicationByProfile",
    values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "initializePublicationCollectModule",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "processCollect",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>
    ]
  ): string;

  decodeFunctionResult(functionFragment: "OSP", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "getFollowerOnlyByPublicationByProfile",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "initializePublicationCollectModule",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "processCollect",
    data: BytesLike
  ): Result;

  events: {};
}

export interface FreeCollectModule extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: FreeCollectModuleInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    OSP(overrides?: CallOverrides): Promise<[string]>;

    getFollowerOnlyByPublicationByProfile(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    initializePublicationCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    processCollect(
      referrerProfileId: PromiseOrValue<BigNumberish>,
      collector: PromiseOrValue<string>,
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[void]>;
  };

  OSP(overrides?: CallOverrides): Promise<string>;

  getFollowerOnlyByPublicationByProfile(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  initializePublicationCollectModule(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    data: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  processCollect(
    referrerProfileId: PromiseOrValue<BigNumberish>,
    collector: PromiseOrValue<string>,
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    data: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<void>;

  callStatic: {
    OSP(overrides?: CallOverrides): Promise<string>;

    getFollowerOnlyByPublicationByProfile(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    initializePublicationCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    processCollect(
      referrerProfileId: PromiseOrValue<BigNumberish>,
      collector: PromiseOrValue<string>,
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {};

  estimateGas: {
    OSP(overrides?: CallOverrides): Promise<BigNumber>;

    getFollowerOnlyByPublicationByProfile(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    initializePublicationCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    processCollect(
      referrerProfileId: PromiseOrValue<BigNumberish>,
      collector: PromiseOrValue<string>,
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    OSP(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    getFollowerOnlyByPublicationByProfile(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    initializePublicationCollectModule(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    processCollect(
      referrerProfileId: PromiseOrValue<BigNumberish>,
      collector: PromiseOrValue<string>,
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
